discussion/urls.py
from django.contrib import admin
from django.urls import include, path

# Every django application always starts with the package that has the same name. In order for us to access the routes of a different package (todolist), then we have to import/include it within the 'urls.py' file within the package that has the same name as the project.
urlpatterns = [
    # By doing this, we are going to be able to access the routes
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

todolist/urls.py
from django.urls import path
from . import views

# You can declare routes by using the path function and having 3 arguments within that function.
# 1st argument - endpoint, 2nd argument - function to be triggered, 3rd argument - label for the route
app_name = 'todolist'
urlpatterns = [
	path('', views.index, name = 'index'),
	# /todolist/<todoitem_id>
	path('<int:todoitem_id>/', views.todoitem, name='viewtodoitem'),
    # /todolist/<events_id>
	path('event/<int:events_id>/', views.events, name='viewevents'),
	# /todolist/register
	path('register', views.register, name="register"),
	# /todolist/change_password
	path('change_password', views.change_password, name="change_password"),
	# /todolist/login
	path('login', views.login_view, name="login"),
	# /todolist/logout
	path('logout', views.logout_view, name="logout"),
	# /todolist/add_task
	path('add_task', views.add_task, name="add_task"),
    # /todolist/add_event
	path('add_event', views.add_event, name="add_event"),
	# /todolist/todoitem_id/edit
	path('<int:todoitem_id>/edit', views.update_task, name='update_task'),
    # /todolist/todoitem_id/edit_event
	path('<int:events_id>/edit_event', views.update_event, name='update_event'),
	# /todolist/todoitem_id/delete
	path('<int:todoitem_id>/delete', views.delete_task, name='delete_task'),
    # /todolist/todoitem_id/delete_event
	path('<int:events_id>/delete_event', views.delete_event, name='delete_event')
]

todolist/models.py
from django.db import models
from django.contrib.auth.models import User

# Create your models here.
class ToDoItem(models.Model):
	task_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default="pending")
	date_created = models.DateTimeField("date created")
	user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

class Events(models.Model):
	event_name = models.CharField(max_length=50)
	description = models.CharField(max_length=200)
	status = models.CharField(max_length=50, default="pending")
	event_date = models.DateTimeField("event date")
	user = models.ForeignKey(User, on_delete=models.CASCADE, default="")

todolist/forms.py
from django import forms

class LoginForm(forms.Form):
	username = forms.CharField(label="Username", max_length=20)
	password = forms.CharField(label="Password", max_length=20)

class AddTaskForm(forms.Form):
	task_name = forms.CharField(label="Task Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)

class UpdateTaskForm(forms.Form):
	task_name = forms.CharField(label="Task Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)
	status = forms.CharField(label='Status', max_length=50)

class RegisterForm(forms.Form):
    username = forms.CharField(label="Username", max_length=20)
    first_name = forms.CharField(label="First Name", max_length=20)
    last_name = forms.CharField(label="Last Name", max_length=20)
    email = forms.CharField(label="Email", max_length=50)
    password = forms.CharField(label="Password", max_length=20)
    confirm_password = forms.CharField(label="Confirm Password", max_length=20)

class AddEventForm(forms.Form):
	event_name = forms.CharField(label="Event Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)

class UpdateEventForm(forms.Form):
	event_name = forms.CharField(label="Event Name", max_length=50)
	description = forms.CharField(label="Description", max_length=200)
	status = forms.CharField(label='Status', max_length=50)

todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.http import HttpResponse
from django.contrib.auth.models import User
from django.contrib.auth import authenticate, login, logout
from django.forms.models import model_to_dict
from django.utils import timezone

# from django.template import loader

# Local imports
from .models import ToDoItem, Events
from .forms import LoginForm, AddTaskForm, UpdateTaskForm, RegisterForm, UpdateEventForm, AddEventForm

# Create your views here.
def index(request):
	# Retrieve a list of all ToDoItem objects from the database
	todoitem_list = ToDoItem.objects.filter(user_id=request.user.id)
	events_list = Events.objects.filter(user_id=request.user.id)
	# output = ', '.join([todoitem.task_name for todoitem in todoitem_list])
	# template = loader.get_template("todolist/index.html")

	# Creates a context dictionary containing data to be passed to the template
	context = { 
		'todoitem_list': todoitem_list,
		'events_list': events_list,
		'user': request.user
	}
	
	return render(request, "todolist/index.html", context)

def todoitem(request, todoitem_id):
	# response = "You are viewing the details of %s"
	# return HttpResponse(response % todoitem_id)
	# The model_to_dict() allows to convert models into dictionaries
	# get() allows to retrieve a record using it primary key(pk)
	todoitem = get_object_or_404(ToDoItem, pk=todoitem_id)
	return render(request, "todolist/todoitem.html", model_to_dict(todoitem))

def events(request, events_id):

	events = get_object_or_404(Events, pk=events_id)
	return render(request, "todolist/events.html", model_to_dict(events))

def register(request):
    if request.method == 'POST':
        
        form = RegisterForm(request.POST)

        if form.is_valid():

            username = form.cleaned_data['username']
            first_name = form.cleaned_data['first_name']
            last_name = form.cleaned_data['last_name']
            email = form.cleaned_data['email']
            password = form.cleaned_data['password']

            
            if not User.objects.filter(username=username).exists():
                
                user = User.objects.create_user(
                    username=username,
                    first_name=first_name,
                    last_name=last_name,
                    email=email,
                    password=password
                )
                user.is_staff = False
                user.is_active = True
                user.save()
                
                login(request, user)

                context = {
                    "first_name": user.first_name,
                    "last_name": user.last_name
                }
                return render(request, "todolist/register.html", context)

    else:
        
        form = RegisterForm()

    context = {
        'form': form,
    }

    return render(request, "todolist/register.html", context)


def change_password(request):
	is_user_authenticated = False

	# authenticates the user
	# returns the user object if found and "None" if not found
	user = authenticate(username="johndoe", password="john1234")
	print(user)

	if user is not None:
		authenticated_user = User.objects.get(username="johndoe")
		authenticated_user.set_password("john1")
		authenticated_user.save()
		is_user_authenticated = True

	context = {
		"is_user_authenticated": is_user_authenticated
	}
	return render(request, "todolist/change_password.html", context)


def login_view(request):

	context = {}

	# If this is a POST request we need to process the form data
	if request.method == 'POST':

		# Creates a form instance and populates it with data from the request
		form = LoginForm(request.POST)

		# Check whether the data is valid
		# Runs validation routines for all the form fields and returns True and places the form's data in the "cleaned_data" attribute
		if form.is_valid() == False:

			# Returns a blank login form
			form = LoginForm()

		else:
			# Retrieves the information from the form
			username = form.cleaned_data['username']
			password = form.cleaned_data['password']

			user = authenticate(username=username, password=password)
			context = {
				"username": username,
				"password": password
			}
	
			if user is not None:
				# Saves or creates a record in the django_session table in the database
				login(request, user)
				# redirects the user to the index.html page
				return redirect("todolist:index")

			else:
				# Provides context with error to conditionally render the error message
				context = {
					"error": True
				}

	return render(request, "todolist/login.html", context)

def logout_view(request):
	logout(request)
	return redirect("todolist:index")

def add_task(request):

	context = {}

	if request.method == 'POST':
		form = AddTaskForm(request.POST)

		if form.is_valid() == False:
			form = AddTaskForm()
		else:
			task_name = form.cleaned_data['task_name']
			description = form.cleaned_data['description']

			# Checks if a task already exists in the database
			duplicates = ToDoItem.objects.filter(task_name=task_name)

			if not duplicates:

				ToDoItem.objects.create(task_name=task_name, description=description, date_created=timezone.now(), user_id=request.user.id)
				return redirect("todolist:index")
			
			else:

				context = {
					"error": True
				}

	return render(request, "todolist/add_task.html", context)

def add_event(request):

	context = {}

	if request.method == 'POST':
		form = AddEventForm(request.POST)

		if form.is_valid() == False:
			form = AddEventForm()
		else:
			event_name = form.cleaned_data['event_name']
			description = form.cleaned_data['description']

			# Checks if a task already exists in the database
			duplicates = Events.objects.filter(event_name=event_name)

			if not duplicates:

				Events.objects.create(event_name=event_name, description=description, event_date=timezone.now(), user_id=request.user.id)
				return redirect("todolist:index")
			
			else:

				context = {
					"error": True
				}

	return render(request, "todolist/add_event.html", context)


def update_task(request, todoitem_id):

    todoitem = ToDoItem.objects.filter(pk=todoitem_id)

    context = {
        "user": request.user,
        "todoitem_id": todoitem_id,
        "task_name": todoitem[0].task_name,
        "description": todoitem[0].description,
        "status" : todoitem[0].status
    }

    if request.method == 'POST':
        form = UpdateTaskForm(request.POST)

        if form.is_valid() == False:
            form = UpdateTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']

            if todoitem:
                todoitem[0].task_name = task_name
                todoitem[0].description = description
                todoitem[0].status = status
                todoitem[0].save()
                return redirect("todolist:index")
            else:
                context = {
                    "error": True
                }

    return render(request, "todolist/update_task.html", context)

def update_event(request, events_id):

    events = Events.objects.filter(pk=events_id)

    context = {
        "user": request.user,
        "events_id": events_id,
        "event_name": events[0].event_name,
        "description": events[0].description,
        "status" : events[0].status
    }

    if request.method == 'POST':
        form = UpdateEventForm(request.POST)

        if form.is_valid() == False:
            form = UpdateEventForm()
        else:
            event_name = form.cleaned_data['event_name']
            description = form.cleaned_data['description']
            status = form.cleaned_data['status']

            if events:
                events[0].event_name = event_name
                events[0].description = description
                events[0].status = status
                events[0].save()
                return redirect("todolist:index")
            else:
                context = {
                    "error": True
                }

    return render(request, "todolist/update_event.html", context)


def delete_task(request, todoitem_id):

	todoitem = ToDoItem.objects.filter(pk=todoitem_id).delete()

	return redirect("todolist:index")

def delete_event(request, events_id):

	events = Events.objects.filter(pk=events_id).delete()

	return redirect("todolist:index")

todolist/templates/todolist/add_event.html
{% extends 'base.html'%}

{% block title %}Add Event{% endblock %}

{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="tex-center my-3">Add an Event</h1>
				{% if error == True %}
					<p class="text-danger">Duplicate event found!</p>
				{% endif %}

				<form action="{% url 'todolist:add_event' %}" method="post">

					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
					{% csrf_token %}

					<div class="mb-3">
						<label for="event_name" class="form-label">Event Name:</label>
						<input type="text" class="form-control" id="event_name" name="event_name" value="{{event_name}}" maxlength="50" required>
					</div>

					<div class="mb-3">
						<label for="description" class="form-label">Description:</label>
						<textarea class="form-control" id="description" name="description" value="{{description}}" required></textarea>
					</div>

					<div class="mb-3">
						
						<input class="btn btn-success" type="submit" value="Add Event">
					</div>
				</form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/todolist/add_task.html
{% extends 'base.html'%}

{% block title %}Add Task{% endblock %}

{% block content %}
	<div class="container">
		<div class="row">
			<div class="col-6 offset-3">
				<h1 class="tex-center my-3">Add a Task</h1>
				{% if error == True %}
					<p class="text-danger">Duplicate task found!</p>
				{% endif %}

				<form action="{% url 'todolist:add_task' %}" method="post">

					<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
					<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
					{% csrf_token %}

					<div class="mb-3">
						<label for="task_name" class="form-label">Task Name:</label>
						<input type="text" class="form-control" id="task_name" name="task_name" value="{{task_name}}" maxlength="50" required>
					</div>

					<div class="mb-3">
						<label for="description" class="form-label">Description:</label>
						<textarea class="form-control" id="description" name="description" value="{{description}}" required></textarea>
					</div>

					<div class="mb-3">
						
						<input class="btn btn-success" type="submit" value="Add Task">
					</div>
				</form>
			</div>
		</div>
	</div>
{% endblock %}

todolist/templates/todolist/change_password.html
{% if is_user_authenticated == False %}
    <h1>Invalid User Credentials!</h1>\
    <p>Check if the username and password are correct</p>
{% else %}
    <h1>User Password Successfully Updated!</h1>
    <p>The password has been successfully updated</p>
{% endif %}        

todolist/templates/todolist/events.html
{% extends 'base.html' %}

{% block title %}My Events{% endblock %}

{% block content %}
<div class="text-center my-3">
	<h1>{{ event_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Status</h3>
	<p>{{ status }}</p>
	<button class="btn btn-primary mx-1 text-decoration-none"><a href="{% url 'todolist:update_event' id %}" class="text-light">Edit Event</a></button>

	<button class="btn btn-danger mx-1 text-decoration-none"><a href="{% url 'todolist:delete_event' id %}" class="text-light">Delete Event</a></button>

	<button class="btn btn-warning mx-1 text-decoration-none"><a href="{% url 'todolist:index' %}" class="text-light">Back to Events</a></button>
</div>

{% endblock %}

todolist/templates/todolist/index.html
{% extends 'base.html' %}

{% block title %}Home{% endblock %}

{% block content %}
	{% if not user.is_anonymous %}

		<h1 class="text-center my-3">Welcome {{ user.username }}!</h1>
		<div class="container">
			<div class="row">
				<h3 class="text-center mb-3">My Tasks</h3>
				<ul class="list-group col-lg-2 offset-lg-5 text-center">
					{% for todoitem in todoitem_list %}
						<li class="list-group-item">
							<a href="{% url 'todolist:viewtodoitem' todoitem.id %}">{{ todoitem.task_name }}</a>
						</li>
					{% endfor %}
				</ul>
			</div>

			<div class="row">
				<h3 class="text-center mb-3">My Events</h3>
				<ul class="list-group col-lg-2 offset-lg-5 text-center">
					{% for events in events_list %}
						<li class="list-group-item">
							<a href="{% url 'todolist:viewevents' events.id %}">{{ events.event_name }}</a>
						</li>
					{% endfor %}
				</ul>
			</div>
		</div>

	{% else %}
		<h1 class="text-center my-3">You are not authorized to access this page.</h1>
		<p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>
	{% endif %}
{% endblock %}

todolist/templates/todolist/login.html
{% extends 'base.html'%}

{% block title %}Login{% endblock %}

{% block content %}

<div class="container">
	<div class="row">
		<div class="col-6 offset-3">
			<h1 class="tex-center my-3">Login</h1>
			{% if error == True %}
				<p class="text-danger">Invalid user credentials. Please check your username and password</p>
			{% endif %}

			<form action="{% url 'todolist:login' %}" method="post">

				<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
				<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
				{% csrf_token %}

				<div class="mb-3">
					<label for="username" class="form-label">Username:</label>
					<input type="text" class="form-control" id="username" name="username" value="{{ username }}" maxlength="20" required>
				</div>

				<div class="mb-3">
					<label for="password" class="form-label">Password:</label>
					<input type="password" class="form-control" id="password" name="password" value="{{ password }}" maxlength="20" required>
				</div>

				<div class="text-center">
					<input class="btn btn-success" type="submit" value="Login">
				</div>
			</form>
		</div>
	</div>
</div>


{% endblock %}

todolist/templates/todolist/register.html
{% extends 'base.html' %}

{% block title %}Register{% endblock %}

{% block content %}
<div class="container">
    <div class="row">
        <div class="col-6 offset-3">
            <h1 class="text-center my-3">Register</h1>
            {% if error == True %}
                <p class="text-danger">Invalid user credentials. Please check your username and password</p>
            {% endif %}
            
            <form action="{% url 'todolist:register' %}" method="post">
                {% csrf_token %}
                <div class="mb-3">
                    <label for="username" class="form-label">Username: </label>
                    <input type="text" class="form-control" id="username" name="username" value="{{username}}" maxlength="20" required>
                </div>

                <div class="mb-3">
                    <label for="first_name" class="form-label">First Name: </label>
                    <input type="text" class="form-control" id="first_name" name="first_name" value="{{first_name}}" maxlength="20" required>
                </div>

                <div class="mb-3">
                    <label for="last_name" class="form-label">Last Name: </label>
                    <input type="text" class="form-control" id="last_name" name="last_name" value="{{last_name}}" maxlength="20" required>
                </div>

                <div class="mb-3">
                    <label for="email" class="form-label">Email Address: </label>
                    <input type="email" class="form-control" id="email" name="email" value="{{email}}" maxlength="20" required>
                </div>

                <div class="mb-3">
                    <label for="password" class="form-label">Password: </label>
                    <input type="password" class="form-control" id="password" name="password" value="{{password}}" maxlength="20" required>
                </div>

                <div class="mb-3">
                    <label for="confirm_password" class="form-label">Confirm Password: </label>
                    <input type="password" class="form-control" id="confirm_password" name="confirm_password" value="{{confirm_password}}" maxlength="20" required>
                </div>

                <div class="text-center">
                    <input class="btn btn-success" type="submit" value="Register">
                </div>

            </form>

        </div>
    </div>
</div>


{% endblock %} 

todolist/templates/todolist/todoitem.html
{% extends 'base.html' %}

{% block title %}My Tasks{% endblock %}

{% block content %}
<div class="text-center my-3">
	<h1>{{ task_name }}</h1>
	<h3>Description</h3>
	<p>{{ description }}</p>
	<h3>Status</h3>
	<p>{{ status }}</p>
	<button class="btn btn-primary mx-1 text-decoration-none"><a href="{% url 'todolist:update_task' id %}" class="text-light">Edit Task</a></button>

	<button class="btn btn-danger mx-1 text-decoration-none"><a href="{% url 'todolist:delete_task' id %}" class="text-light">Delete Task</a></button>

	<button class="btn btn-warning mx-1 text-decoration-none"><a href="{% url 'todolist:index' %}" class="text-light">Back to Tasks</a></button>
</div>

{% endblock %}

todolist/templates/todolist/update_event.html
{% extends 'base.html' %}

{% block title %}Update Event{% endblock %}

{% block content %}

	{% if user.is_anonymous == False %}
		<div class="container">
			<div class="row">
				<div class="col-6 offset-3">
					<h1 class="text-center">Update Event</h1>
					{% if error == True %}
						<p class="text-danger">Event not found</p>
					{% endif %}

					<form action="{% url 'todolist:update_event' events_id %}" method="post">
						<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
						<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
						{% csrf_token %}

						<div class="mb-3">
							<label for="event_name" class="form-label">Event Name:</label>
							<input type="text" class="form-control" id="event_name" name="event_name" value="{{event_name}}" maxlength="50" required>
						</div>

						<div class="mb-3">
							<label for="description" class="form-label">Description:</label>
							<textarea class="form-control" id="description" name="description" value="{{description}}" required>{{ description }}</textarea>
						</div>

						<div class="mb-3">
							<label for="status" class="form-label">Status:</label>
							<input class="form-control" id="status" name="status" value="{{status}}" required></input>
						</div>

						<div class="mb-3">					
							<input class="btn btn-success" type="submit" value="Update Event">
						</div>

					</form>
				</div>
			</div>
		</div>

		{% else %}
			<h1 class="tex-center my-3">You are not authorized to access this page.</h1>
			<p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>

		{% endif %}
{% endblock %}

todolist/templates/todolist/update_task.html
{% extends 'base.html' %}

{% block title %}Update Task{% endblock %}

{% block content %}

	{% if user.is_anonymous == False %}
		<div class="container">
			<div class="row">
				<div class="col-6 offset-3">
					<h1 class="text-center">Update Task</h1>
					{% if error == True %}
						<p class="text-danger">Task not found</p>
					{% endif %}

					<form action="{% url 'todolist:update_task' todoitem_id %}" method="post">
						<!-- This template tag provides protection against Cross Site Request Forgeries (CSRF) -->
						<!-- CSRF occurs when a malicious website contains a link, a form button or some JavaScript that is intended to perform some action our website, using the credentials of a logged-in user -->
						{% csrf_token %}

						<div class="mb-3">
							<label for="task_name" class="form-label">Task Name:</label>
							<input type="text" class="form-control" id="task_name" name="task_name" value="{{task_name}}" maxlength="50" required>
						</div>

						<div class="mb-3">
							<label for="description" class="form-label">Description:</label>
							<textarea class="form-control" id="description" name="description" value="{{description}}" required>{{ description }}</textarea>
						</div>

						<div class="mb-3">
							<label for="status" class="form-label">Status:</label>
							<input class="form-control" id="status" name="status" value="{{status}}" required></input>
						</div>

						<div class="mb-3">					
							<input class="btn btn-success" type="submit" value="Update Task">
						</div>

					</form>
				</div>
			</div>
		</div>

		{% else %}
			<h1 class="tex-center my-3">You are not authorized to access this page.</h1>
			<p class="text-center">Kindly login <a href="{% url 'todolist:login' %}">here</a></p>

		{% endif %}
{% endblock %}